## mingw-w64-blender-4.0.2-6.src.tar.zst

=== doc/python_api/requirements.txt ===
sphinx==7.1.2

# Sphinx dependencies that are important
Jinja2==3.1.2
Pygments==2.16.1
docutils==0.18.1
snowballstemmer==2.2.0
requests==2.31.0

# Only needed to match the theme used for the official documentation.
# Without this theme, the default theme will be used.
sphinx_rtd_theme==1.3.0rc1
